BasicGraphUI.RootHandle (JGraph v5.12.4.2 API Specification)
Keywords: org.jgraph.plaf.basic.BasicGraphUI.RootHandle class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JGraph v5.12.4.2
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jgraph.plaf.basic
Class BasicGraphUI.RootHandle

    java.lang.Object
      org.jgraph.plaf.basic.BasicGraphUI.RootHandle

All Implemented Interfaces:
  CellHandle, Serializable

Enclosing class:
  BasicGraphUI

public class BasicGraphUI.RootHandle
extends Object
implements CellHandle, Serializable

See Also:
  Serialized Form

Field Summary
`protected double` | `_mouseToViewDelta_x`
`protected double` | `_mouseToViewDelta_y`
`protected CellHandle` | `activeHandle` The handle that consumed the last mousePressedEvent.
`protected boolean` | `blockPaint`
`protected Rectangle2D` | `cachedBounds`
`protected GraphContext` | `context`
`protected CellView[]` | `contextViews`
`protected Point2D` | `current`
`protected ConnectionSet` | `disconnect`
`protected boolean` | `firstDrag`
`protected CellHandle[]` | `handles`
`protected CellView` | `ignoreTargetGroup`
`protected Point2D` | `initialLocation`
`protected boolean` | `isContextVisible`
`protected boolean` | `isDragging` Indicates whether this handle has started drag and drop.
`protected boolean` | `isMoving` Indicates whether this handle is currently moving cells.
`protected Point2D` | `last`
`protected Graphics` | `offgraphics` Reference to graph off screen graphics
`protected CellView[]` | `portViews`
`protected Point2D` | `snapLast`
`protected Point2D` | `snapStart`
`protected Point2D` | `start`
`protected CellView` | `targetGroup`
`protected CellView[]` | `views`

Constructor Summary
`BasicGraphUI.RootHandle(GraphContext ctx)` Creates a root handle which contains handles for the given cells.

Method Summary
`protected Point2D` | `constrainDrag(MouseEvent event, double totDx, double totDy, double dx, double dy)` Hook method to constrain a mouse drag
`protected CellView` | `findUnselectedInnermostGroup(double x, double y)` Used for move into group to find the target group.
`protected CellView` | `findViewForPoint(Point2D pt)` Hook for subclassers to return a different view for a mouse click at `pt`.
`GraphContext` | `getContext()`
`Component` | `getFirstOpaqueParent(Component component)`
`protected Point2D` | `getInitialLocation(Object[] cells)` Returns the initial location, which is the top left corner of the selection, ignoring all connected endpoints of edges.
`protected void` | `initOffscreen()`
`void` | `mouseDragged(MouseEvent event)` Process mouse dragged event.
`void` | `mouseMoved(MouseEvent event)` Invoked when the mouse pointer has been moved on a component (with no buttons down).
`void` | `mousePressed(MouseEvent event)` Messaged when a mouse button is pressed.
`void` | `mouseReleased(MouseEvent event)` Messaged when the drag operation has terminated with a drop.
`void` | `overlay(Graphics g)` Paint the handle on the given graphics object during mouse operations.
`void` | `paint(Graphics g)` Paint the handle on the given graphics object once.
`protected void` | `startDragging(MouseEvent event)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### _mouseToViewDelta_x

    protected transient double _mouseToViewDelta_x

### _mouseToViewDelta_y

    protected transient double _mouseToViewDelta_y

### firstDrag

    protected transient boolean firstDrag

### views

    protected transient CellView[] views

### contextViews

    protected transient CellView[] contextViews

### portViews

    protected transient CellView[] portViews

### targetGroup

    protected transient CellView targetGroup

### ignoreTargetGroup

    protected transient CellView ignoreTargetGroup

### cachedBounds

    protected transient Rectangle2D cachedBounds

### initialLocation

    protected transient Point2D initialLocation

### handles

    protected transient CellHandle[] handles

### start

    protected transient Point2D start

### last

    protected transient Point2D last

### snapStart

    protected transient Point2D snapStart

### snapLast

    protected transient Point2D snapLast

### offgraphics

    protected transient Graphics offgraphics

  Reference to graph off screen graphics

### isMoving

    protected boolean isMoving

  Indicates whether this handle is currently moving cells. Start may be non-null and isMoving false while the minimum movement has not been reached.

### isDragging

    protected boolean isDragging

  Indicates whether this handle has started drag and drop. Note: isDragging => isMoving.

### activeHandle

    protected transient CellHandle activeHandle

  The handle that consumed the last mousePressedEvent. Initially null.

### context

    protected transient GraphContext context

### isContextVisible

    protected boolean isContextVisible

### blockPaint

    protected boolean blockPaint

### current

    protected Point2D current

### disconnect

    protected transient ConnectionSet disconnect

Constructor Detail

### BasicGraphUI.RootHandle

    public BasicGraphUI.RootHandle(GraphContext ctx)

  Creates a root handle which contains handles for the given cells. The root handle and all its childs point to the specified JGraph instance. The root handle is responsible for dragging the selection.

Method Detail

### getInitialLocation

    protected Point2D getInitialLocation(Object[] cells)

  Returns the initial location, which is the top left corner of the selection, ignoring all connected endpoints of edges.

### getContext

    public GraphContext getContext()

### paint

    public void paint(Graphics g)

  Description copied from interface: `CellHandle`
  Paint the handle on the given graphics object once.

  Specified by:
    `paint` in interface `CellHandle`
  Parameters:
    `g` - the graphics object to paint the handle on

### overlay

    public void overlay(Graphics g)

  Description copied from interface: `CellHandle`
  Paint the handle on the given graphics object during mouse operations.

  Specified by:
    `overlay` in interface `CellHandle`
  Parameters:
    `g` - the graphics object to paint the handle on

### mouseMoved

    public void mouseMoved(MouseEvent event)

  Invoked when the mouse pointer has been moved on a component (with no buttons down).

  Specified by:
    `mouseMoved` in interface `CellHandle`
  Parameters:
    `event` - the mouse event to be processed

### mousePressed

    public void mousePressed(MouseEvent event)

  Description copied from interface: `CellHandle`
  Messaged when a mouse button is pressed.

  Specified by:
    `mousePressed` in interface `CellHandle`
  Parameters:
    `event` - the mouse event to be processed

### findViewForPoint

    protected CellView findViewForPoint(Point2D pt)

  Hook for subclassers to return a different view for a mouse click at `pt`. For example, this can be used to return a leaf cell instead of a group.

### findUnselectedInnermostGroup

    protected CellView findUnselectedInnermostGroup(double x,
                                                    double y)

  Used for move into group to find the target group.

### startDragging

    protected void startDragging(MouseEvent event)

### getFirstOpaqueParent

    public Component getFirstOpaqueParent(Component component)

  Returns:
    Returns the parent graph scrollpane for the specified graph.

### initOffscreen

    protected void initOffscreen()

### mouseDragged

    public void mouseDragged(MouseEvent event)

  Process mouse dragged event.

  Specified by:
    `mouseDragged` in interface `CellHandle`
  Parameters:
    `event` - the drag event to be processed

### constrainDrag

    protected Point2D constrainDrag(MouseEvent event,
                                    double totDx,
                                    double totDy,
                                    double dx,
                                    double dy)

  Hook method to constrain a mouse drag

  Parameters:
    `event` -
    `totDx` -
    `totDy` -
    `dx` -
    `dy` -
  Returns:
    a point describing any position constraining applied

### mouseReleased

    public void mouseReleased(MouseEvent event)

  Description copied from interface: `CellHandle`
  Messaged when the drag operation has terminated with a drop.

  Specified by:
    `mouseReleased` in interface `CellHandle`
  Parameters:
    `event` - the drop event to be processed

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JGraph v5.12.4.2
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) 2001-2008 Gaudenz Alder. All rights reserved.